namespace XmlSmsSender.Test
{
    using Xunit;
    using xml.sender;

    public class MultiSmsTest
    {
        [Fact]
        public void How_To_Use_Send_MultiSms()
        {
            string Channel = "AVEA";
            string Originator = "TRANSAY";
            string Password = "pass";
            string Username = "user";
            var smsMulti = new SmsMultiSender
            {
                Channel = Channel,
                Originator = Originator,
                Password = Password,
                Username = Username
            };

            // Test telefonlar
            var SOFOR_TELEFON = "905554443322";
            var YOLCU_TELEFON = "905554443321";


            var Text = "Test Mesajlar";
            smsMulti.AddMessage(YOLCU_TELEFON, Text);
            smsMulti.AddMessage(SOFOR_TELEFON, Text);

            //Salanan altyapda ayn mesajn ayn numaraya birden fazla defa gnderilmesi yasakl, flooding e giriyor

            ResponseFromHost response = null;
            try
            {
                response = smsMulti.sendMessage("http://service.jetsms.com.tr/SMS-Web8/xmlsms");
            }
            catch (System.Exception ex)
            {
                var exceptionMessage = ex.Message;
            }

            Assert.NotNull(response);
        }
    }
}
