﻿/*
* Created on 12.Eyl.2005
*/
using System;
using System.Collections;
using System.Configuration;

namespace xml.sender
{
	
	public class SmsReport
	{
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the groupid.
		/// </returns>
		/// <param name="">groupid
		/// The groupid to set.
		/// </param>
		virtual public System.String Groupid
		{
			get
			{
				return groupid;
			}
			
			set
			{
				this.groupid = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the password.
		/// </returns>
		/// <param name="">password
		/// The password to set.
		/// </param>
		virtual public System.String Password
		{
			get
			{
				return password;
			}
			
			set
			{
				this.password = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the status.
		/// </returns>
		/// <param name="">status
		/// The status to set.
		/// </param>
		virtual public System.String Status
		{
			get
			{
				return status;
			}
			
			set
			{
				this.status = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the username.
		/// </returns>
		/// <param name="">username
		/// The username to set.
		/// </param>
		virtual public System.String Username
		{
			get
			{
				return username;
			}
			
			set
			{
				this.username = value;
			}
			
		}
		private System.String username;
		private System.String password;
		private System.String groupid;
		private System.String status;
		
		public SmsReport(System.String username, System.String password, System.String groupid, System.String status)
		{
			Username = username;
			Password = password;
			Groupid = groupid;
			Status = status;
		}
		
		public SmsReport()
		{
			
		}

        //UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
        public ArrayList doReporting()
        {
            return doReporting(ConfigurationSettings.AppSettings["XML_REPORT_SERVLET"]);
        }
		
		//UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
		public ArrayList doReporting(string url)
		{
			//UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
			ArrayList returnList = new ArrayList();
			//UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
			ArrayList response;
			System.String requestString;
			System.String[] tokens = null;
			System.String responseLine;
			HttpClient httpClient;
			MessageResponse messageResponse;
			
			//UPGRADE_TODO: Method 'java.util.ResourceBundle.getString' was converted to 'System.Resources.ResourceManager.GetString()' which has a different behavior. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1073"'
            String urlStr = url;
			if(urlStr == null)
			{
                throw new XmlSmsReportException("Set the XML_REPORT_SERVLET property on configuration file first");
			}
			requestString =  urlStr + "?username=" + Username + "&password=" + Password + "&groupid=" + Groupid + "&status=" + Status;
			
			httpClient = new HttpClient(requestString);
			httpClient.connectAsGet();
			response = httpClient.ResponseAll;
			httpClient.disconnect();
			if (response == null)
			{
                throw new XmlSmsReportException("01 Timeout has occurred");
			}
			
			for (int i = 0; i < response.Count; i++)
			{
				responseLine = (String)response[i]; 
				tokens = responseLine.Split(new char[]{' '});
				if (tokens.Length == 1)
					throw new Exception("02 Corrupted Return Message");
				if (tokens[0] == "99" || tokens[0] == "10" || tokens[0] == "11") 
				{
					throw new XmlSmsReportException(responseLine); 
				}				
				else
				{
					if (tokens.Length >= 3)
					{
						if (tokens[0] != groupid)
                            throw new XmlSmsReportException("02 Corrupted Return Message");
						messageResponse = new MessageResponse();
						messageResponse.setGsmNumber(tokens[1]);
						messageResponse.setStatus(tokens[2]);
						if (tokens.Length >= 4)
						{
							messageResponse.setSentDate(tokens[3]);
						}
						if (tokens.Length == 5)
						{
							messageResponse.setResponseFromTelsimDate(tokens[4]);
						}
						returnList.Add(messageResponse);
					}else
                        throw new XmlSmsReportException("02 Corrupted Return Message");
				}
			}
			return returnList;
		}

	}
}