/*
* Created on 12.Eyl.2005
*/
using System;
namespace xml.sender
{
	
	public class MessageResponse
	{
		
		private System.String gsmNumber;
		private System.String status;
		private System.String sentDate;
		private System.String responseFromTelsimDate;
        private System.String messageId;
		
		
		public MessageResponse():base()
		{
		}
		
		public MessageResponse(System.String gsmNumber, System.String status)
		{
			setGsmNumber(gsmNumber);
			setStatus(status);
		}
		
		/// <returns> Returns the gsmNumber.
		/// </returns>
		public virtual System.String getGsmNumber()
		{
			return gsmNumber;
		}
		
		/// <param name="gsmNumber">The gsmNumber to set.
		/// </param>
		internal virtual void  setGsmNumber(System.String gsmNumber)
		{
			this.gsmNumber = gsmNumber;
		}
		
		/// <returns> Returns the status.
		/// </returns>
		public virtual System.String getStatus()
		{
			return status;
		}
		
		/// <param name="status">The status to set.
		/// </param>
		internal virtual void  setStatus(System.String status)
		{
			this.status = status;
		}
		
		/// <returns> Returns the getResponseFromTelsimDate.
		/// </returns>
		public virtual System.String getResponseFromTelsimDate()
		{
			return responseFromTelsimDate;
		}
		
		/// <param name="getResponseFromTelsimDate">The getResponseFromTelsimDate to set.
		/// </param>
		internal virtual void  setResponseFromTelsimDate(System.String getResponseFromTelsimDate)
		{
			this.responseFromTelsimDate = getResponseFromTelsimDate;
		}
		
		/// <returns> Returns the sentDate.
		/// </returns>
		public virtual System.String getSentDate()
		{
			return sentDate;
		}
		
		/// <param name="sentDate">The sentDate to set.
		/// </param>
		internal virtual void  setSentDate(System.String sentDate)
		{
			this.sentDate = sentDate;
		}

        /// <returns> Returns the getMessageId.
		/// </returns>
        public virtual System.String getMessageId()
		{
			return messageId;
		}

        /// <param name="getMessageId">The getMessageId to set.
		/// </param>
        internal virtual void setMessageId(System.String getMessageId)
		{
            this.messageId = getMessageId;
		}
		//UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
		//Override
		public override string ToString()
		{
            return getGsmNumber() + " " + getStatus() + " " + getSentDate() + " " + getResponseFromTelsimDate() + " " + getMessageId();
		}

		
	}

    public class MessageReport
    {
        private System.String gsmNumber;
        private System.String status;
        private System.String sentDate;
        private System.String delivered;
        private System.String messageId;
        private System.String responseCode;

        public System.String GsmNumber
        {
            set { gsmNumber = value; }
            get { return gsmNumber; }
        }
        public System.String Status
        {
            set { status = value; }
            get { return status; }
        }
        public System.String SentDate
        {
            set { sentDate = value; }
            get { return sentDate; }
        }
        public System.String Delivered
        {
            set { delivered = value; }
            get { return delivered; }
        }
        public System.String MessageId
        {
            set { messageId = value; }
            get { return messageId; }
        }
        public System.String ResponseCode
        {
            set { responseCode = value; }
            get { return responseCode; }
        }
        
        //UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
        //Override
        public override string ToString()
        {
            return GsmNumber + " " + Status + " " + SentDate + " " + Delivered + " " + MessageId + " " + ResponseCode;
        }
    }

    public class MessageResponseV2
    {
        private string responseCode;
        private string responseMessage;
        private MessageReport[] messageReportArray;

        virtual public string ResponseCode
        {
            set { responseCode = value; }
            get { return responseCode; }
        }

        virtual public string ResponseMessage
        {
            set { responseMessage = value; }
            get { return responseMessage; }
        }

        virtual public MessageReport[] MessageReportArray
        {
            set { messageReportArray = value; }
            get { return messageReportArray; }
        }
    }


}