﻿/*
* Created on 15.May.2005
*/
using System;
namespace xml.sender
{
    #region v1.0
    

    public class ResponseFromHost
    {
        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the code.
        /// </returns>
        /// <param name="code">The code to set.
        /// </param>
        virtual public System.String Code
        {
            get
            {
                return code;
            }

            set
            {
                this.code = value;
            }

        }
        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the message.
        /// </returns>
        /// <param name="message">The message to set.
        /// </param>
        virtual public System.String Message
        {
            get
            {
                return message;
            }

            set
            {
                this.message = value;
            }

        }

        private System.String code;
        private System.String message;

        public ResponseFromHost(System.String code, System.String message)
        {
            Code = code;
            Message = message;
        }

        public ResponseFromHost()
        {
        }

        public override System.String ToString()
        {
            return "Code:" + Code + "\n" + "Message:" + Message;
        }

        [STAThread]
        protected static void Main(System.String[] args)
        {

        }
    }
    #endregion

    #region v2.0
    public class ResponseGroupId
    {
        private string gsmNumber;
        private string messageId;
        private string status;

        virtual public string GsmNumber
        {
            set { gsmNumber = value; }
            get { return gsmNumber; }
        }

        virtual public string MessageId
        {
            set { messageId = value; }
            get { return messageId; }
        }

        virtual public string Status
        {
            set { status = value; }
            get { return status; }
        }
    }

    public class ResponseFromHostV2
    {
        private string responseCode;
        private string responseMessage;
        private ResponseGroupId[] responseGroupIdArray;

        virtual public string ResponseCode
        {
            set { responseCode = value; }
            get { return responseCode; }
        }

        virtual public string ResponseMessage
        {
            set { responseMessage = value; }
            get { return responseMessage; }
        }

        virtual public ResponseGroupId[] ResponseGroupIdArray
        {
            set { responseGroupIdArray = value; }
            get { return responseGroupIdArray; }
        }

    } 
    #endregion
}