﻿using System;
using System.Collections;
using System.Configuration;
using xml.sender;

namespace xml.sender
{
	/// <summary>
	/// Summary description for SmsReportByDate.
	/// </summary>
	public class SmsReportByDate
	{
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the groupid.
		/// </returns>
		/// <param name=>groupid
		/// The groupid to set.
		/// </param>
		virtual public System.String EndDate
		{
			get
			{
				return enddate;
			}
			
			set
			{
				this.enddate= value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the password.
		/// </returns>
		/// <param name=>password
		/// The password to set.
		/// </param>
		virtual public System.String Password
		{
			get
			{
				return password;
			}
			
			set
			{
				this.password = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the status.
		/// </returns>
		/// <param name=>status
		/// The status to set.
		/// </param>
		virtual public System.String StartDate
		{
			get
			{
				return startdate;
			}
			
			set
			{
				this.startdate = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the username.
		/// </returns>
		/// <param name="">username
		/// The username to set.
		/// </param>
		virtual public System.String Username
		{
			get
			{
				return username;
			}
			
			set
			{
				this.username = value;
			}
			
		}

		virtual public System.String GroupId
		{
			get
			{
				return groupid;
			}
			
			set
			{
				this.groupid = value;
			}
			
		}

		private System.String username;
		private System.String password;
		private System.String startdate;
		private System.String enddate;
		private System.String groupid;

		public SmsReportByDate(System.String username, System.String password, System.String startdate, System.String enddate,System.String groupId)
		{
			Username = username;
			Password = password;
			StartDate = startdate;
			EndDate = enddate;
			GroupId = groupId;
		}

		public SmsReportByDate()
		{
			
		}
		
		//UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
		public ArrayList doReporting()
		{
			//UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
			ArrayList returnList = new ArrayList();
			//UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
			ArrayList response;
			System.String requestString;
			System.String[] tokens = null;
			System.String responseLine;
			HttpClient httpClient;
			MessageResponse messageResponse;
			
			//UPGRADE_TODO: Method 'java.util.ResourceBundle.getString' was converted to 'System.Resources.ResourceManager.GetString()' which has a different behavior. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1073"'
			String urlStr = ConfigurationSettings.AppSettings["XML_DATE_REPORT_SERVLET"];
			if(urlStr == null)
			{
				throw new Exception("Set the XML_DATE_REPORT_SERVLET property on configuration file first");
			}
			requestString =  urlStr + "?username=" + Username + "&password=" + Password + "&sdate=" + startdate+ "&edate=" + enddate;
			
			httpClient = new HttpClient(requestString);
			httpClient.connectAsGet();
			response = httpClient.ResponseAll;
			httpClient.disconnect();
			if (response == null)
			{
				throw new System.Exception("01 Timeout has occurred");
			}
			
			for (int i = 0; i < response.Count; i++)
			{
				responseLine = (String)response[i]; 
				tokens = responseLine.Split(new char[]{' '});
				if (tokens.Length == 1)
					throw new Exception("02 Corrupted Return Message");
				if (tokens[0] == "99" || tokens[0] == "10" || tokens[0] == "11") 
				{
					throw new Exception(responseLine); 
				}				
				else
				{
					if (tokens.Length >= 3)
					{
						if (tokens[0] != groupid)
							throw new Exception("02 Corrupted Return Message");
						messageResponse = new MessageResponse();
						messageResponse.setGsmNumber(tokens[1]);
						messageResponse.setStatus(tokens[2]);
						if (tokens.Length >= 4)
						{
							messageResponse.setSentDate(tokens[3]);
						}
						if (tokens.Length == 5)
						{
							messageResponse.setResponseFromTelsimDate(tokens[4]);
						}
						returnList.Add(messageResponse);
					}
					else
						throw new Exception("02 Corrupted Return Message");
				}
			}
			return returnList;
		}
		
		[STAThread]
		public static void  Main(System.String[] args)
		{
			try
			{
				SmsReport smsReport = new SmsReport("user", "passw", "grupid", "5");
				
				ArrayList  responseList = smsReport.doReporting();
				for (int i = 0; i < responseList.Count; i++)
				{
					MessageResponse messageResponse = (MessageResponse)responseList[i];
					System.Console.Out.WriteLine(messageResponse);
				}
			}
			catch (System.Exception ex)
			{
				SupportClass.WriteStackTrace(ex, Console.Error);
			}
		}
	}
}
