﻿/*
* Created on 15.May.2005
*/
using System;
using System.Text;
namespace xml.sender
{	

	public class SmsToMany:SmsBase
	{
        //StringBuilder gsmNumbersXml = new StringBuilder();
        StringBuilder xmlToSend = new StringBuilder();
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the text.
		/// </returns>
		/// <param name="text">The text to set.
		/// </param>
		virtual public System.String Text
		{
			get
			{
				if ((System.Object) text == null)
					throw new SmsCreationException("Sms message text must be set in the message.");
				return text;
			}
			
			set
			{
				this.text = ConvertNonEnglishChar(value);
			}
			
		}
		private string ConvertNonEnglishChar(string xml)
		{
			/*
			xml = xml.Replace("İ","I");
			xml = xml.Replace("Ğ","G");
			xml = xml.Replace("ğ","g");
			xml = xml.Replace("Ş","S");
			xml = xml.Replace("ş","s");
			xml = xml.Replace("Ü","U");
			xml = xml.Replace("ü","u");
			xml = xml.Replace("ı","i");
			xml = xml.Replace("Ç","C");
			xml = xml.Replace("ç","c");
			xml = xml.Replace("Ö","O");
			xml = xml.Replace("ö","o");
			*/
			return xml;
		}
		
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the username.
		/// </returns>
		/// <param name="MessageType">The username to set.
		/// </param>		

        //virtual public System.String MessageType
        //{
        //    get
        //    {
        //        if ((System.Object) messageType == null)
        //            return "";
        //        return messageType;
        //    }
			
        //    set
        //    {
        //        this.messageType = value;
        //    }
			
        //}
        ////UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        ///// <returns> Returns the username.
        ///// </returns>
        ///// <param name="MessageHeader">The username to set.
        ///// </param>		
        //virtual public System.String MessageHeader
        //{
        //    get
        //    {
        //        if ((System.Object) messageHeader == null)
        //            return "0";
        //        return messageHeader;
        //    }
			
        //    set
        //    {
        //        this.messageHeader = value;
        //    }
			
        //}


        //virtual public System.String ExclusionTimeStart
        //{
        //    get { return exclusionTimeStart; }
        //    set { exclusionTimeStart = value; }
        //}
		
        //virtual public System.String ExclusionTimeStop
        //{
        //    get { return exclusionTimeStop; }
        //    set { exclusionTimeStop = value; }
        //}

		private System.String text;
        //private System.String messageType;
        //private System.String messageHeader;
        //private System.String exclusionTimeStart;
        //private System.String exclusionTimeStop;
		
		//UPGRADE_ISSUE: Class hierarchy differences between 'java.util.ArrayList' and 'System.Collections.ArrayList' may cause compilation errors. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1186"'
		private System.Collections.ArrayList gsmNumbers;
		/* 
		* @see xml.sender.SmsBase#sendMessage()
		*/
		public ResponseFromHost sendMessage(System.String xmlSentServlet)
		{
            return PostDataToHost(CreateXmlData(), xmlSentServlet);
		}

        
        private string CreateXmlData()
        {
            if (smsMessages == null || smsMessages.Length == 0)
            {
                throw new SmsCreationException("The GSM number(s) must be set in the message.");
            }

            xmlToSend.Remove(0, xmlToSend.Length);

            xmlToSend.Append("<?xml version=\"1.0\" encoding=\"utf-8\" ");
            xmlToSend.Append("?>");
            xmlToSend.Append("<message-context type=\"smmgsd\" ");
            if (isResponseMultiGroupId)
            {
                xmlToSend.Append("version=\"2.0\" >");
            }
            else
            {
                xmlToSend.Append(">");
            }
            xmlToSend.Append("<version>");
            xmlToSend.Append(Version);
            xmlToSend.Append("</version>");
            xmlToSend.Append("<exclusion-time-start>");
            xmlToSend.Append(ExclusionTimeStart);
            xmlToSend.Append("</exclusion-time-start>");
            xmlToSend.Append("<exclusion-time-stop>");
            xmlToSend.Append(ExclusionTimeStop);
            xmlToSend.Append("</exclusion-time-stop>");
            xmlToSend.Append("<message-type>");
            xmlToSend.Append(MessageType);
            xmlToSend.Append("</message-type>");
            xmlToSend.Append("<message-header>");
            xmlToSend.Append(MessageHeader);
            xmlToSend.Append("</message-header>");
            xmlToSend.Append("<username>");
            xmlToSend.Append(Username);
            xmlToSend.Append("</username>");
            xmlToSend.Append("<password>");
            xmlToSend.Append(Password);
            xmlToSend.Append("</password>");
            xmlToSend.Append("<email-report>");
            xmlToSend.Append(EmailReportAddress);
            xmlToSend.Append("</email-report>");
            xmlToSend.Append("<outbox-name>");
            xmlToSend.Append(OutboxName);
            xmlToSend.Append("</outbox-name>");
            xmlToSend.Append("<reference>");
            xmlToSend.Append(Reference);
            xmlToSend.Append("</reference>");
            xmlToSend.Append("<start-date>");
            xmlToSend.Append(StartDate);
            xmlToSend.Append("</start-date>");
            xmlToSend.Append("<expire-date>");
            xmlToSend.Append(ExpireDate);
            xmlToSend.Append("</expire-date>");



            xmlToSend.Append("<text>");
            xmlToSend.Append(Text);
            xmlToSend.Append("</text>");

            xmlToSend.Append("<state>");
            if (0 < base.PackageState)
                xmlToSend.Append(base.PackageState);
            xmlToSend.Append("</state>");

            xmlToSend.Append("<total-count>");
            if (0 < base.TotalMessageCount)
                xmlToSend.Append(base.TotalMessageCount);
            xmlToSend.Append("</total-count>");

            xmlToSend.Append("<unit-count>");
            xmlToSend.Append(smsMessages.Length);
            xmlToSend.Append("</unit-count>");

            xmlToSend.Append("<trn-sqn>");
            if (0 < base.TrnSqn)
                xmlToSend.Append(base.TrnSqn);
            xmlToSend.Append("</trn-sqn>");

            xmlToSend.Append("<operation-process-id>");
            if (!string.IsNullOrEmpty(base.OperationProcessID))
                xmlToSend.Append(base.OperationProcessID);
            xmlToSend.Append("</operation-process-id>");

            xmlToSend.Append("<process-type>");
            if (!string.IsNullOrEmpty(base.ProcessType))
                xmlToSend.Append(base.ProcessType);
            xmlToSend.Append("</process-type>");

            xmlToSend.Append("<blacklist-filter>");
            xmlToSend.Append(base.IsBlacklistFilterActive ? 1 : 0);
            xmlToSend.Append("</blacklist-filter>");

            xmlToSend.Append("<optin-filter>");
            xmlToSend.Append(base.IsOptinFilterActive ? 1 : 0);
            xmlToSend.Append("</optin-filter>");

            xmlToSend.Append("<is-tckn>");
            xmlToSend.Append(base.IsTCKN ? 1 : 0);
            xmlToSend.Append("</is-tckn>");

            xmlToSend.Append("<is-vkn>");
            xmlToSend.Append(base.IsVKN ? 1 : 0);
            xmlToSend.Append("</is-vkn>");

            xmlToSend.Append("<channel>");
            xmlToSend.Append(base.Channel);
            xmlToSend.Append("</channel>");

            decimal generatedMessageId = -1;
            int c = 0;
            foreach (SmsMessage sm in smsMessages)
            {
                if (generatedMessageId == -1)
                {
                    generatedMessageId = GetMessageId();
                }

                xmlToSend.Append("<message>");
                xmlToSend.Append("<gsmno>");
                xmlToSend.Append(sm.GsmNumber);
                xmlToSend.Append("</gsmno>");
                xmlToSend.Append("<message-id>");
                xmlToSend.Append(sm.MessageId == -1 ? generatedMessageId + c : sm.MessageId);//-1 ise unique üretilir
                xmlToSend.Append("</message-id>");
                xmlToSend.Append("</message>");

                c++;
            }

            
            xmlToSend.Append("</message-context>");

            return xmlToSend.ToString();
        }

		public override ResponseFromHost sendMessage()
		{
            return PostDataToHost(CreateXmlData());
		}

        public override ResponseFromHostV2 sendMessageV2()
        {
            isResponseMultiGroupId = true;

            return PostDataToHostV2(CreateXmlData());
        }

        public ResponseFromHostV2 sendMessageV2(System.String xmlSentServlet)
        {
            isResponseMultiGroupId = true;

            return PostDataToHostV2(CreateXmlData(), xmlSentServlet);
        }

        /*multi message_id*/
        private SmsMessage[] smsMessages;

		/// <returns> Returns the gsmNumbers.
		/// </returns>
		//UPGRADE_ISSUE: Class hierarchy differences between 'java.util.ArrayList' and 'System.Collections.ArrayList' may cause compilation errors. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1186"'
		public virtual System.Collections.ArrayList getGsmNumbers()
		{
			//UPGRADE_TODO: The equivalent in .NET for method 'java.util.ArrayList.size' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
			if (gsmNumbers == null || gsmNumbers.Count <= 0)
				throw new SmsCreationException("The GSM number(s) must be set in the message.");
			return gsmNumbers;
		}
		/// <param name="gsmNumbers">The gsmNumbers to set.
		/// </param>
		//UPGRADE_ISSUE: Class hierarchy differences between 'java.util.ArrayList' and 'System.Collections.ArrayList' may cause compilation errors. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1186"'
		/*
        public virtual void  setGsmNumbers(System.Collections.ArrayList gsmNumbers)
		{
			this.gsmNumbers = gsmNumbers;
		}
		public virtual void  setGsmNumbers(System.Object[] gsmNumbers)
		{
			if (gsmNumbers == null)
				this.gsmNumbers = null;
			else
			{
				//UPGRADE_ISSUE: Class hierarchy differences between 'java.util.ArrayList' and 'System.Collections.ArrayList' may cause compilation errors. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1186"'
				this.gsmNumbers = new System.Collections.ArrayList();
				for (int i = 0; i < gsmNumbers.Length; i++)
				{
					//UPGRADE_TODO: The equivalent in .NET for method 'java.util.ArrayList.add' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
					this.gsmNumbers.Add(gsmNumbers[i]);
				}
			}
		}
         * */

        public virtual void setGsmNumbers(System.Collections.ArrayList gsmNumbers)
        {
            this.smsMessages = new SmsMessage[gsmNumbers.Count];
            for (int i = 0; i < gsmNumbers.Count; i++)
            {
                smsMessages[i].GsmNumber = gsmNumbers[i].ToString();
            }
        }
        public virtual void setGsmNumbers(System.Object[] gsmNumbers)
        {
            if (gsmNumbers == null)
            {
                this.smsMessages = null;
            }
            else
            {
                this.smsMessages = new SmsMessage[gsmNumbers.Length];
                for (int i = 0; i < gsmNumbers.Length; i++)
                {
                    smsMessages[i] = new SmsMessage();
                    smsMessages[i].GsmNumber = gsmNumbers[i].ToString();
                }
            }
        }

        public virtual void setGsmNumberAndMessageId(SmsMessage[] gsmNumberAndGroupId)
        {
            if (gsmNumberAndGroupId == null)
                this.smsMessages = null;
            else
            {
                this.smsMessages = gsmNumberAndGroupId;
            }
        }
    }
}